import numpy
import scipy
import os
import numpy,random,time,math
from scipy import stats

def freturn_rows_un_id(un_id,f):
    id1=numpy.where(f[:,0]==un_id[0])
    id2=numpy.where(f[:,1]==un_id[1])
    return numpy.intersect1d(id1,id2)

def freturn_rows_un_id2(un_id,dqm):

    id1=numpy.where(dqm[:,0]==un_id[0])
    id2=numpy.where(dqm[:,1]==un_id[1])
    id12=numpy.intersect1d(id1,id2)

    id3=numpy.where(dqm[:,0]==un_id[1])
    id4=numpy.where(dqm[:,1]==un_id[0])
    id34=numpy.intersect1d(id3,id4)
    
    return id12,id34

def f_un_id_index(un_ids,f):
    [[un_ids[i,0], un_ids[i,1],freturn_rows_un_id(un_ids[i,0:2],f)] for i in range(0,len(un_ids))]

def fReadFile2(fname):    
    fopen= open(fname,'r')
    datastr=fopen.readlines()
    header=datastr[0:3]
    data=[f.rstrip().split() for f in datastr[3:]]
    DQM=numpy.array(data,dtype=float)
    return header,DQM,datastr

def fsplitandjoin(datastr,flag):
    d1=datastr.split()[2:]
    d1.append(str(flag[0])+'\n')
    return ' '.join(d1)

def fChangeCheckFile2(textFile,h,datastr,id_comb, flags,un_id):
    fpath=os.path.dirname(textFile)
    fname=os.path.basename(textFile)
    fname=fname.split('.')[0]
    fname=os.path.join(fpath,fname+'_'+str(int(un_id[0]))+'_'+str(int(un_id[1]))+'.txt')

    fopen=open(fname,'w+');
    l2=h[1].split()[2:]
    l2.append(',Flag'+'\n')
    fopen.write(fpath.split('.')[0]+'\n')
    fopen.write(''.join(l2))
    #s=[fsplitandjoin(datastr[x+2],flags[x]) for x in xrange(0,len(flags))]
    s=[fsplitandjoin(datastr[id_comb[x]+2],flags[x]) for x in range(0,len(flags))]
    #print s[0],s[1],s[2]
    fopen.writelines(s)
    fopen.close()
    return 1

def fUnique2D(A):
    A0=numpy.int16(A[:,0])
    A1=numpy.int16(A[:,1])
    S={str(int(A0[x]))+'_'+str(int(A1[x])) for x in range(0,len(A0))}
    X=[x.split('_') for x in S]
    Y=[[int(x[0]),int(x[1])] for x in X]
    #print Y
    return numpy.array(Y)

def fPRINT(fname,PXYZ):
    def retstr(x):
        for citer in range(0,len(x)):
            s=s+str(x[citer])+'\t'
        s=s+'\n'
    fp=open(fname,'w+')
    if(len(PXYZ[0])==2):
       map(lambda x: fp.write(str(x[0])+'\t'+str(x[1])+'\n'),PXYZ)
    elif(len(PXYZ[0])==3):
       map(lambda x: fp.write(str(x[0])+'\t'+str(x[1])+'\t'+str(x[2])+'\n'),PXYZ)
    elif(len(PXYZ[0])==4):
        map(lambda x: fp.write(str(x[0])+'\t'+str(x[1])+'\t'+str(x[2])+'\t'+str(x[3])+'\n'),PXYZ)
    else:
        map(lambda x: fp.write(retstr(x)),PXYZ)
    fp.close()

def fCreateBatchFile(DirectoryPath, OutputDirectorypath,UNITS_FACTOR):
    os.chdir(OutputDirectorypath)
    OFile= open('runDQM.bat','w+')
    OFile.write('set path= %Path%;C:\DQM\DQM_Test')
    if (UNITS_FACTOR!=1):
        cm="\nDQManage -i "+ '"'+DirectoryPath +'\*.laz'+'"'+' -step 15 -nearest 25 -tiles -eigen_ratio .005 -max_number 1000 -single_only -drop_withheld"'
    else:
        cm="\nDQManage -i "+ '"'+DirectoryPath +'\*.laz'+'"'+' -step 10 -nearest 25 -tiles -eigen_ratio .005 -max_number 1000 -single_only -drop_withheld"'
    
    OFile.write(cm)
    OFile.close()
    os.system('runDQM.bat')
    os.system('del runDQM.bat')    
    
def fGenerateAnalysis(DirectoryPath, UNITS_FACTOR,MIN_PTS,h_error,v_error,angle):
    textFileList=[]
    for f in os.listdir(DirectoryPath):
        if f.startswith('check') and f.endswith(".txt"):
            textFileList.append(os.path.join(DirectoryPath, f))
    print (textFileList)
    os.chdir(DirectoryPath)

    OFile= open('SummaryStats.txt','w+')
    OFile2= open('PotentialErrorFile.txt','w+')
    OFile3= open('AcceptableFiles.txt','w+')

    OFile2.write('DQM File'+'\t'+'File Name 1'+'\t'+'File Name 2'+'\t')
    #OFile2.write('Max Potential Roll Error'+'\t')
    OFile2.write('Number Sample Points'+'\t')
    #OFile2.write('Slope'+'\t'+'Intercept'+'\t'+'Dist_Max'+'\t')
    OFile2.write('mean_dZ'+'\t'+'Std_dZ'+'\t'+'RMSE_dZ'+'\t'+'Discrepancy Angle'+'\t')
    #OFile2.write('Num_HS'+'\t'+'Mean HS'+'\t'+'Std HS'+'\t'+'Max D_HS'+'\t')
    OFile2.write('Num_HS'+'\t')
    OFile2.write('dX'+'\t'+'dY'+'\t'+'dXY'+'\n')

    OFile3.write('DQM File'+'\t'+'File Name 1'+'\t'+'File Name 2'+'\t')
    #OFile3.write('Max Potential Roll Error'+'\t')
    OFile3.write('Number Sample Points'+'\t')
    #OFile3.write('Slope'+'\t'+'Intercept'+'\t'+'Dist_Max'+'\t')
    OFile3.write('mean_dZ'+'\t'+'Std_dZ'+'\t'+'RMSE_dZ'+'\t'+'Discrepancy Angle'+'\t')
    #OFile3.write('Num_HS'+'\t'+'Mean HS'+'\t'+'Std HS'+'\t'+'Max D_HS'+'\t')
    OFile3.write('Num_HS'+'\t')
    OFile3.write('dX'+'\t'+'dY'+'\t'+'dXY'+'\n')

    for textFile in textFileList:
        print (textFile)
        fProcOutPutFile(textFile,OFile,OFile2,OFile3,UNITS_FACTOR,MIN_PTS)
    OFile.close()
    OFile2.close()
    OFile3.close()

def fGetCenterlineEq(xyz):
    #xyz is an x-y data in most cases for this function
    # all 'planes' should be replaced by line
    xyzm=xyz.mean(axis=0)
    LineEq=numpy.zeros((1,5)) # 1 X 5 vector of planar parameters   
    covMat=numpy.cov((xyz-xyzm).transpose()) # generate covariance matric covMat
    evv=numpy.linalg.eig(covMat)# get eigen vales and eigen vectors of covMat
    indmin=evv[0].argmin()    # gets the index of Minimum eigen value. Gives direction of most variance

    LineEq[0][0]=evv[1][0,indmin] # Median line eq has same parameters as eigen vectors corresponding to min eigen value
    LineEq[0][1]=evv[1][1,indmin] # Median line eq has same parameters as eigen vectors corresponding to min eigen value
    
    a=evv[1][:,indmin][0];b=evv[1][:,indmin][1]; # Median Line eq. aX+bY+c=0 and a^2+b^2=1
    
    # c is determined as below
    c=-(a*xyzm[0]+b*xyzm[1])
    return a,b,c

def fMAD(X,e):
    med=numpy.median(X)
    mad=numpy.median(abs(X-med))
    in1=[x for x in range(0,len(X)) if abs(X[x]-med)/mad < e]
    #print in1
    return numpy.array([x for x in range(0,len(X)) if abs(X[x]-med)/mad < e])

def fProcOutPutFile(textFile,OFile,OFile2,OFile3, UNITS_FACTOR,MIN_PTS):
    fpath=os.path.dirname(textFile)
    #fname='check_10TFL638866.txt'
    fn=textFile
    h,dqm,datastr=  fReadFile2(fn)
    un_ids=fUnique2D(dqm[:,0:2])
    #un_ids=numpy.unique(numpy.sort(un_ids,1),axis=0)
    un_ids=fUnique2D(numpy.sort(un_ids,1))

    #MIN_PTS=10
    #UNITS_FACTOR=1
    DQM_U=dqm

    for uid in un_ids:
        id12,id34=freturn_rows_un_id2(uid,DQM_U)
        id_comb=numpy.union1d(id12,id34)
        DQM_U[id34,5:9]=-DQM_U[id34,5:9]
        
        DQM=DQM_U[id_comb,2:]
        dX=0
        dY=0
        if(DQM.shape[0]>MIN_PTS):
            dX=max(DQM[:,0])-min(DQM[:,0])
            dY=max(DQM[:,1])-min(DQM[:,1])
        #print dX,dY
        Total_Points=DQM.shape[0]
        Flag_Used_Pts=numpy.zeros((Total_Points,1),dtype=int)
        if(DQM.shape[0]>MIN_PTS):
            # The next line does:
            # Ratio of eigenvalues should be less than .001
            # DQM[x,7] is the variance of neighborhood size
            # DQM[x,8]/DQM[x,7] is the ratio to enforce that neighborhoods are not very thin or skinny and they are closer to circular neighborhood
            ind_DQM=[x for x in range(0,DQM.shape[0]) if DQM[x,9]/(DQM[x,7]+DQM[x,8]+DQM[x,9]) < .001 and DQM[x,7] < 25/(UNITS_FACTOR*UNITS_FACTOR) and DQM[x,8]/DQM[x,7] > .45 and math.sqrt(DQM[x,9])<.06]
            Flag_Used_Pts[ind_DQM]=1
            DQM=DQM[ind_DQM,:]

            if(DQM.shape[0]>MIN_PTS):
                mx=DQM[:,0].min()
                my=DQM[:,1].min()
                mz=DQM[:,3].min()
                    # Moving origin to Min X,Y,Z for more stable calculation
                DQM[:,0]=DQM[:,0]-mx
                DQM[:,1]=DQM[:,1]-my
                DQM[:,2]=DQM[:,2]-mz
                avgPtSpacing=numpy.array([math.sqrt(DQM[x,8])+math.sqrt(DQM[x,7]) for x in range(0,DQM.shape[0])])
                avgPtSpacing=avgPtSpacing.mean()/2
                a,b,c=fGetCenterlineEq(DQM[:,0:2]) # Get center line equation            
                dist_medial=numpy.array([a*x[0]+b*x[1]+c for x in DQM])
                ind_pl=[x for x in range(0,len(DQM)) if math.acos(DQM[x,5])*180/math.pi < 5]
                
                
                ind_pl_inliers=fMAD(DQM[ind_pl,6],7)
                ind_pl=[ind_pl[x] for x in ind_pl_inliers]

                # The next lines flags all points considered to be flat regions
                for x in ind_pl:
                    Flag_Used_Pts[ind_DQM[x]]=1
                    

                ind_Slp=[x for x in range(0,len(DQM)) if math.acos(DQM[x,5])*180/math.pi > 5]
                
                
                ind_Slp_inliers=fMAD(DQM[ind_Slp,6],6)
                ind_Slp=[ind_Slp[x] for x in ind_Slp_inliers]

                N=DQM[ind_Slp,3:6]
                Dx=DQM[ind_Slp,6]

               
                # The next lines flags all points considered to be Sloping regions
                for x in ind_Slp:
                    Flag_Used_Pts[ind_DQM[x]]=1
                

                if (len(N)>5):
                    dXYZ=numpy.linalg.lstsq(N,Dx)[0]
                else:
                    dXYZ=numpy.zeros((3,1))


                Val=fChangeCheckFile2(textFile,h,datastr,id_comb,Flag_Used_Pts,uid)        
                
                if(len(ind_pl)>MIN_PTS):
                    slope, intercept, r_value, p_value, std_err = stats.linregress(dist_medial[ind_pl],DQM[ind_pl,6])
                    DA=numpy.array([math.atan(DQM[x,13]/abs(dist_medial[x])) for x in ind_pl if dist_medial[x] > 100]) # The Overlap has to be at least 100 units
                    if(len(DA)>MIN_PTS):
                        medDA=numpy.median(DA)*180/math.pi
                    else:
                        medDA=0

                    OFile.write('**********************************'+'\n')
                    OFile.write(textFile.rstrip().split('\\').pop()+'\t'+str(uid[0])+'\t'+str(uid[1])+'\n')
                    err_max=abs(abs(dist_medial[ind_pl]).max()*slope+intercept)
                    OFile.write('Max Potential Roll Error::'+str(err_max)+'\n')
                    RMSE=numpy.sqrt(numpy.multiply(DQM[ind_pl,6],DQM[ind_pl,6]).mean())
                    
                    if(medDA>0.1 or math.sqrt(DQM[ind_pl,6].mean()**2 + DQM[ind_pl,6].std()**2)>.15/UNITS_FACTOR):
                        print(DQM[ind_pl,6].max(),DQM[ind_pl,6].min())
                        OFile2.write(textFile.rstrip().split('\\').pop()+'\t'+str(uid[0])+'\t'+str(uid[1])+'\t'+str(len(ind_pl))+'\t')
                        OFile2.write(str(DQM[ind_pl,6].mean())+'\t'+str(DQM[ind_pl,6].std())+'\t'+str(RMSE)+'\t'+str(medDA)+'\t')
                        if(len(ind_Slp)>2):
                            OFile2.write(str(len(ind_Slp))+'\t')
                            OFile2.write(str(dXYZ[0])+'\t'+str(dXYZ[1])+'\t'+str(math.sqrt(dXYZ[1]**2+dXYZ[0]**2))+'\n')
                        else:
                            OFile2.write(str(len(ind_Slp))+'\t')
                            OFile2.write(str(dXYZ[0])+'\t'+str(dXYZ[1])+'\t'+str(math.sqrt(dXYZ[1]**2+dXYZ[0]**2))+'\n')
                            
                                
                    else:
                        if(len(ind_Slp)>0):
                            print(str(DQM[ind_Slp,13].max()))
                        OFile3.write(textFile.rstrip().split('\\').pop()+'\t'+str(uid[0])+'\t'+str(uid[1])+'\t'+str(len(ind_pl))+'\t')
                        OFile3.write(str(DQM[ind_pl,6].mean())+'\t'+str(DQM[ind_pl,6].std())+'\t'+str(RMSE)+'\t'+str(medDA)+'\t')
                        if(len(ind_Slp)>2):
                            OFile3.write(str(len(ind_Slp))+'\t')
                            OFile3.write(str(dXYZ[0])+'\t'+str(dXYZ[1])+'\t'+str(math.sqrt(dXYZ[1]**2+dXYZ[0]**2))+'\n')
                        else:
                            OFile3.write(str(len(ind_Slp))+'\t')
                            OFile3.write(str(dXYZ[0])+'\t'+str(dXYZ[1])+'\t'+str(math.sqrt(dXYZ[1]**2+dXYZ[0]**2))+'\n')
        else:
            print ('Not enough samples')
